/*
 *  GPSdo - Software for GPSDO
 *  (c) Ad Sekeris 2019
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * File: display_func.h - contains all display related functions
 */

bool Fresh_Start = true;
unsigned long Led1Blink, Led2Blink, Led3Blink;
int ScreenPrevious = -1;
int ScreenNew = 0;
unsigned long ProgRunTime, OldRunTime;
unsigned long ProgFixTime, OldFixTime;
unsigned long LcdTotTime, OldLcdTotTime;
unsigned long AnalogTime, OldAnalogTime;
unsigned int Running_Seconds, Running_Minutes, Running_Hours, Running_Days;
unsigned int Fix_Seconds, Fix_Minutes, Fix_Hours, Fix_Days;
int NewFixMode = 0, OldFixMode = -1;
int NewSatsInView = 0, OldSatsInView = -1;
int NewSatsInUse = 0, OldSatsInUse = -1;
int GpsTimeSecondNew = 0, GpsTimeMinuteNew = 0, GpsTimeHourNew = 0;
int LocalTimeSecondNew = 0, LocalTimeMinuteNew = 0, LocalTimeHourNew = 0;
int GpsTimeSecondOld = -1, GpsTimeMinuteOld = -1, GpsTimeHourOld = -1;
int LocalTimeSecondOld = 0, LocalTimeMinuteOld = 0, LocalTimeHourOld = 0;
int GpsDateDayNew = 0, GpsDateMonthNew = 0, GpsDateYearNew = 0;
int LocalDateDayNew = 0, LocalDateMonthNew = 0, LocalDateYearNew = 0;
int GpsDateDayOld = -1, GpsDateMonthOld = -1, GpsDateYearOld = -1;
int LocalDateDayOld = -1, LocalDateMonthOld = -1, LocalDateYearOld = -1;
byte EncoderRotate, EncoderPush;
char SATS_IN_USE[] = " 0/";
char SATS_IN_VIEW[] = " 0";
char PROG_RUN_TIME[]= "   0  0:00:00", OLD_RUN_TIME[]= "   0  0:00:00";
char PROG_FIX_TIME[]= "   0  0:00:00", OLD_FIX_TIME[]= "   0  0:00:00";
char NEW_UTC_TIME[] = " 0: 0: 0", OLD_UTC_TIME[] = " 0: 0: 0";
char NEW_UTC_DATE[] = " 0/ 0/   0", OLD_UTC_DATE[] = " 0/ 0/   0";
char NEW_LAT[] = "000.000000", OLD_LAT[] = "000.000000";
char NEW_LAT_IND[] = " ", OLD_LAT_IND[] = " ";
char NEW_LNG[] = "000.000000", OLD_LNG[] = "000.000000";
char NEW_LNG_IND[] = " ", OLD_LNG_IND[] = " ";
char NEW_LOCATOR[] = "      ", OLD_LOCATOR[] = "      ";
double Lattitude, Longitude;
bool LatUpdate = false, LngUpdate = false;
char EmptyLine[] = "                    ";
float AnInput0 = 0.0;
float AnInHigh0 = 130.0;
float AnInOld0 = 0.0;
unsigned int NeedlePos = 0;
unsigned int OldNeedlePos = 0;
unsigned long MeterDwellTime = 0;

void LcdmeterInit() {
  byte BlockVal = 0;
  uint8_t Lend[8]    = {0x07,0x07,0x06,0x06,0x06,0x06,0x07,0x07};
  uint8_t Rend[8]    = {0x1C,0x1C,0x0C,0x0C,0x0C,0x0C,0x1C,0x1C};
  uint8_t Needle0[8] = {0x1F,0x1F,0x00,0x00,0x00,0x00,0x1F,0x1F};
  uint8_t Needle1[8] = {0x1F,0x1F,0x0E,0x0E,0x0E,0x0E,0x1F,0x1F};

  lcd.createChar(0, Lend);
  lcd.createChar(1, Rend);
  lcd.createChar(2, Needle0);
  lcd.createChar(3, Needle1);
}

void NeedlePosition ()
{
  AnInOld0 = (0.95 * AnInOld0) + (0.05 * AnInput0); // new value counts for 5%  <<<< this is the running average thingie, you can change the %% as long as the both add up to 1.0
  NeedlePos = map(AnInOld0,0,MeterMaxVal,0,79);
}

LCD2004Meter() 
{
  unsigned int BlockVal;
  byte ScreenPos = 2;
  char TempField[] = "    ";
  BlockVal = map(NeedlePos,0,79,0,15);
  lcd.setCursor(2,2);
  do {
    if (BlockVal == (ScreenPos-2)) lcd.print ((char)3);
    else lcd.print ((char)2);
    ScreenPos ++;  
  } while (ScreenPos < 18);
//  #ifdef USB_DEBUG 
//      Serial.print(" Needle: ");
//      Serial.print(NeedlePos);
//      Serial.print(" Blok: ");
//      Serial.println(BlockVal);
//  #endif
  if (EditMode) {
    lcd.setCursor(0, 3);
    sprintf(TempField, "%4d", round(WeighedHigh));
    lcd.print(TempField);
    lcd.setCursor(6, 3);
    lcd.print("Eeprom:");
    sprintf(TempField, "%4d", MeterMaxVal);
    lcd.print(TempField);
  }
}

void LcdWipeClean()
{
 #if (LCD_2004)
   lcd.setCursor(0,0);
   lcd.print(EmptyLine);
   lcd.print(EmptyLine);
   lcd.print(EmptyLine);
   lcd.print(EmptyLine);
 #endif 
}

void LedSwitch (int Ledpin, int Ledmode, int Ledstatus) {
  pinMode (Ledpin, OUTPUT);  // Set the output mode for the led to control
  if (Ledmode == SINGLEL){
    if (Ledstatus == SINGLE_OFF) digitalWrite (Ledpin, HIGH); else digitalWrite (Ledpin, LOW);  // Pin is Sinking Low for Led on
  }
  else if (Ledmode == SINGLEH){
    if (Ledstatus == SINGLE_OFF) digitalWrite (Ledpin, LOW); else digitalWrite (Ledpin, HIGH);  // Pin is sourcing High for Led on  
  }
  else if (Ledmode == 2){
    // Here should be the code for bicolor Led's
  }
}

// given a Timezone object, UTC and a string description, convert and print local time with time zone
void printDateTime(Timezone tz, time_t utc, const char *descr)
{
    char buf[40];
    char m[4];    // temporary storage for month string (DateStrings.cpp uses shared buffer)
    TimeChangeRule *tcr;        // pointer to the time change rule, use to get the TZ abbrev

    time_t t = tz.toLocal(utc, &tcr);
    strcpy(m, monthShortStr(month(t)));
    sprintf(buf, "%.2d:%.2d:%.2d %s %.2d %s %d %s",
        hour(t), minute(t), second(t), dayShortStr(weekday(t)), day(t), m, year(t), tcr -> abbrev);
    Serial.print(buf);
    Serial.print(' ');
    Serial.println(descr);
}

void DisplayLocator()
{
  if (strcmp(NEW_LOCATOR,OLD_LOCATOR)!=0) {
    strncpy(OLD_LOCATOR, NEW_LOCATOR, 6);
    #if (LCD_2004)
      lcd.setCursor(7,3);
      lcd.print(NEW_LOCATOR);
    #endif 
  }
}

void calcLocator(char *dst, double lat, double lon) {
  int o1, o2, o3;
  int a1, a2, a3;
  double remainder;
  // longitude
  remainder = lon + 180.0;
  o1 = (int)(remainder / 20.0);
  remainder = remainder - (double)o1 * 20.0;
  o2 = (int)(remainder / 2.0);
  remainder = remainder - 2.0 * (double)o2;
  o3 = (int)(12.0 * remainder);

  // latitude
  remainder = lat + 90.0;
  a1 = (int)(remainder / 10.0);
  remainder = remainder - (double)a1 * 10.0;
  a2 = (int)(remainder);
  remainder = remainder - (double)a2;
  a3 = (int)(24.0 * remainder);
  dst[0] = (char)o1 + 'A';
  dst[1] = (char)a1 + 'A';
  dst[2] = (char)o2 + '0';
  dst[3] = (char)a2 + '0';
  dst[4] = (char)o3 + 'a';
  dst[5] = (char)a3 + 'a';
  dst[6] = (char)0;
}

void UpdateLongitude()
{
  float lat_d1;
  int lat_d;
  float lat_m1;
  int lat_m;
  float lat_s; 
  int lat_sec;
  int lat_sec2;
  float RawLng = gps.location.lng();
  Longitude = RawLng;
  dtostrf(abs(RawLng),10, 6, NEW_LNG);
  if (strcmp(NEW_LNG,OLD_LNG)!=0) {
    LngUpdate = true;
    if (ScreenNew == 3) {
      dtostrf(RawLng,10, 6, OLD_LNG);
      #if (LCD_2004)
        lcd.setCursor(7,2);
        lcd.print(NEW_LNG);
      #endif 
    }
    if (ScreenNew == 4) {
      char New_Pos_d[] = "000";
      char New_Pos_m[] = "00";
      char New_Pos_s1[] = "00.";
      char New_Pos_s2[] = "00 ";
      lat_d1 = abs(RawLng);
      lat_d = lat_d1;
      lat_m1 = (lat_d1 - lat_d) * 60;
      lat_m = lat_m1;
      lat_s = (lat_m1 - lat_m) * 60;
      lat_sec = lat_s;
      lat_sec2 = (lat_s - lat_sec) * 100;
      sprintf(New_Pos_d,"%3d",lat_d);
      sprintf(New_Pos_m,"%02d'",lat_m);
      sprintf(New_Pos_s1,"%02d.",lat_sec);
      sprintf(New_Pos_s2,"%02d\"",lat_sec2);
      #if (LCD_2004)
        lcd.setCursor(7,2);
        lcd.print(New_Pos_d);
        lcd.print((char)223);
        lcd.print(New_Pos_m);
        lcd.print(New_Pos_s1);
        lcd.print(New_Pos_s2);
      #endif       
    }
    if (RawLng >= 0)NEW_LNG_IND[0] = char(69); else NEW_LNG_IND[0] = char(87);
    if (strcmp(NEW_LNG_IND,OLD_LNG_IND)!=0) {
      if (RawLng >= 0)OLD_LNG_IND[0] = char(69); else OLD_LNG_IND[0] = char(87);
       #if (LCD_2004)
         lcd.setCursor(5,2);
         lcd.print(NEW_LNG_IND[0]);
       #endif  
    }  
  }
}    

void UpdateLattitude()
{
  float lat_d1;
  int lat_d;
  float lat_m1;
  int lat_m;
  float lat_s; 
  int lat_sec;
  int lat_sec2;
  float RawLat = gps.location.lat();
  Lattitude = RawLat;
  dtostrf(abs(RawLat),10, 6, NEW_LAT);
  if (strcmp(NEW_LAT,OLD_LAT)!=0) {
    LatUpdate = true;
    if (ScreenNew == 3) {
      dtostrf(RawLat,10, 6, OLD_LAT);
      #if (LCD_2004)
        lcd.setCursor(7,1);
        lcd.print(NEW_LAT);
      #endif  
    }
    if (ScreenNew == 4) {
      char New_Pos_d[] = "000";
      char New_Pos_m[] = "00";
      char New_Pos_s1[] = "00.";
      char New_Pos_s2[] = "00 ";
      lat_d1 = abs(RawLat);
      lat_d = lat_d1;
      lat_m1 = (lat_d1 - lat_d) * 60;
      lat_m = lat_m1;
      lat_s = (lat_m1 - lat_m) * 60;
      lat_sec = lat_s;
      lat_sec2 = (lat_s - lat_sec) * 100;
      sprintf(New_Pos_d,"%3d",lat_d);
      sprintf(New_Pos_m,"%02d'",lat_m);
      sprintf(New_Pos_s1,"%02d.",lat_sec);
      sprintf(New_Pos_s2,"%02d\"",lat_sec2);
      #if (LCD_2004)
        lcd.setCursor(7,1);
        lcd.print(New_Pos_d);
        lcd.print((char)223);
        lcd.print(New_Pos_m);
        lcd.print(New_Pos_s1);
        lcd.print(New_Pos_s2);
      #endif       
    }
    if (RawLat >= 0)NEW_LAT_IND[0] = char(78); else NEW_LAT_IND[0] = char(83);
    if (strcmp(NEW_LAT_IND,OLD_LAT_IND)!=0) {
      if (RawLat >= 0)OLD_LAT_IND[0] = char(78); else OLD_LAT_IND[0] = char(83);
        #if (LCD_2004)
          lcd.setCursor(5,1);
          lcd.print(NEW_LAT_IND[0]);
        #endif  
     }   
   }    
}  

void UpdateUtcTime()
{
  char Hours[]= " 0", Minutes[] = ":00", Seconds[]= ":00";
  GpsTimeHourNew=gps.time.hour();
  GpsTimeMinuteNew=gps.time.minute();
  GpsTimeSecondNew=gps.time.second();
  if (GpsTimeHourNew!=GpsTimeHourOld) {
    sprintf(Hours,"%2d",GpsTimeHourNew);
    GpsTimeHourOld = GpsTimeHourNew;
    if (ScreenNew == 0){
      #if (LCD_2004)
        lcd.setCursor(5, 1);
        lcd.print(Hours);
      #endif  
    }
    if (ScreenNew == 2){
      #if (LCD_2004)
        lcd.setCursor(0, 2);
        lcd.print(Hours);
      #endif  
    }
  }
  if (GpsTimeMinuteNew!=GpsTimeMinuteOld) {
    GpsTimeMinuteOld = GpsTimeMinuteNew;
    sprintf(Minutes,":%02d",GpsTimeMinuteNew);
    if (ScreenNew == 0){
      #if (LCD_2004)
        lcd.setCursor(7, 1);
        lcd.print(Minutes);
      #endif  
    }
    if (ScreenNew == 2){
      #if (LCD_2004)
        lcd.setCursor(2,2);
        lcd.print(Minutes);
      #endif  
    }
  }
  if (GpsTimeSecondNew!=GpsTimeSecondOld) {
    GpsTimeSecondOld = GpsTimeSecondNew;
    Led2Stat = SINGLE_ON; 
    LedSwitch (Led2,Led2Mode,SINGLE_ON);  // New GPS time. second led on as timpepulse
    Led2Blink = millis();
    sprintf(Seconds,":%02d",GpsTimeSecondNew);
    if (ScreenNew == 0){
      #if (LCD_2004)
        lcd.setCursor(10, 1);
        lcd.print(Seconds);
      #endif  
    }
    if (ScreenNew == 2){
      #if (LCD_2004)
        lcd.setCursor(5,2);
        lcd.print(Seconds);
      #endif  
    }
  }
}

void UpdateLocalTime(){
  char Hours[]= " 0", Minutes[] = ":00", Seconds[]= ":00";
  setTime(GpsTimeHourNew, GpsTimeMinuteNew, GpsTimeSecondNew, GpsDateDayNew, GpsDateMonthNew, GpsDateYearNew);        //another way to set the time (hr,min,sec,day,mnth,yr)
  time_t utc = now();
  time_t local = CE.toLocal(utc, &tcr);
  LocalTimeHourNew = hour(local);
  LocalTimeMinuteNew = minute(local);
  LocalTimeSecondNew = second(local);
  if (LocalTimeHourNew!=LocalTimeHourOld) {
    LocalTimeHourOld = LocalTimeHourNew;
    sprintf(Hours,"%2d",LocalTimeHourNew);
    if (ScreenNew == 1) {
      #if (LCD_2004)
        lcd.setCursor(7, 1);
        lcd.print(Hours);
      #endif  
    }
    if (ScreenNew == 2){
      #if (LCD_2004)
        lcd.setCursor(10, 2);
        lcd.print(Hours);
      #endif  
    }
  }
  if (LocalTimeMinuteNew!=LocalTimeMinuteOld) {
    LocalTimeMinuteOld = LocalTimeMinuteNew;
    sprintf(Minutes,":%02d",LocalTimeMinuteNew);
    if (ScreenNew == 1){
      #if (LCD_2004)
        lcd.setCursor(9, 1);
        lcd.print(Minutes);
      #endif  
    }
    if (ScreenNew == 2){
      #if (LCD_2004)
        lcd.setCursor(12,2);
        lcd.print(Minutes);
      #endif  
    }
  }
  if (LocalTimeSecondNew!=LocalTimeSecondOld) {
    LocalTimeSecondOld = LocalTimeSecondNew;
    sprintf(Seconds,":%02d",LocalTimeSecondNew);
    if (ScreenNew == 1){
      #if (LCD_2004)
        lcd.setCursor(12, 1);
        lcd.print(Seconds);
        lcd.print(" ");
        lcd.print(tcr -> abbrev);
      #endif  
    }
    if (ScreenNew == 2){
      #if (LCD_2004)
        lcd.setCursor(15,2);
        lcd.print(Seconds);
        lcd.setCursor(16,1);
        lcd.print(tcr -> abbrev);
      #endif  
    }
  }
}

void UpdateUtcDate(){
  char Date[]= " 0", Month[] = "/ 0", Year[]= "/0000";
  GpsDateDayNew=gps.date.day();
  GpsDateMonthNew=gps.date.month();
  GpsDateYearNew=gps.date.year();
  if (GpsDateDayNew!=GpsDateDayOld) {
    GpsDateDayOld = GpsDateDayNew;
    sprintf(Date,"%2d",GpsDateDayNew);
    if (ScreenNew == 0){
      #if (LCD_2004)
        lcd.setCursor(5, 2);
        lcd.print(Date);
      #endif  
    }
    if (ScreenNew == 2){
      #if (LCD_2004)
        lcd.setCursor(0, 3);
        lcd.print(Date);
      #endif  
    }
  }
  if (GpsDateMonthNew!=GpsDateMonthOld) {
    GpsDateMonthOld = GpsDateMonthNew;
    sprintf(Month,"/%02d",GpsDateMonthNew);
    if (ScreenNew == 0){
      #if (LCD_2004)
        lcd.setCursor(7, 2);
        lcd.print(Month);
      #endif  
    }
    if (ScreenNew == 2){
      #if (LCD_2004)
        lcd.setCursor(2, 3);
        lcd.print(Month);
      #endif  
    }
  }
  if (GpsDateYearNew!=GpsDateYearOld) {
    GpsDateYearOld = GpsDateYearNew;
    sprintf(Year,"/%4d",GpsDateYearNew);
    if (ScreenNew == 0){
      #if (LCD_2004)
        lcd.setCursor(10, 2);
        lcd.print(Year);
      #endif  
    }
    if (ScreenNew == 2){
      #if (LCD_2004)
        lcd.setCursor(5, 3);
        lcd.print(Year[0]);
        lcd.print(Year[3]);
        lcd.print(Year[4]);
      #endif  
    }
  }
}

void UpdateLocalDate(){
  char Date[]= " 0", Month[] = "/ 0", Year[]= "/0000";
  time_t utc = now();
  time_t local = CE.toLocal(utc, &tcr);
  LocalDateDayNew = day(local);
  LocalDateMonthNew = month(local);
  LocalDateYearNew = year(local);
  if (LocalDateDayNew!=LocalDateDayOld) {
    LocalDateDayOld = LocalDateDayNew;
    sprintf(Date,"%2d",LocalDateDayNew);
    if (ScreenNew == 1){
      #if (LCD_2004)
        lcd.setCursor(7, 2);
        lcd.print(Date);
      #endif  
    }
    if (ScreenNew == 2){
      #if (LCD_2004)
        lcd.setCursor(10, 3);
        lcd.print(Date);
      #endif  
    }
  }
  if (LocalDateMonthNew!=LocalDateMonthOld) {
    LocalDateMonthOld = LocalDateMonthNew;
    sprintf(Month,"/%02d",LocalDateMonthNew);
    if (ScreenNew == 1){
      #if (LCD_2004)
        lcd.setCursor(9, 2);
        lcd.print(Month);
      #endif  
    }
    if (ScreenNew == 2){
      #if (LCD_2004)
        lcd.setCursor(12, 3);
        lcd.print(Month);
      #endif  
    }
  }
  if (LocalDateYearNew!=LocalDateYearOld) {
    LocalDateYearOld = LocalDateYearNew;
    sprintf(Year,"/%4d",LocalDateYearNew);
    if (ScreenNew == 1){
      #if (LCD_2004)
        lcd.setCursor(12, 2);
        lcd.print(Year);
      #endif  
    }
    if (ScreenNew == 2){
      #if (LCD_2004)
        lcd.setCursor(15,3);
        lcd.print(Year[0]);
        lcd.print(Year[3]);
        lcd.print(Year[4]);
      #endif  
    }
  }
}

void UpdateSatsInUse ()
{
  NewSatsInUse = String(satsInUse.value()).toInt();
  if (NewSatsInUse != OldSatsInUse){
    sprintf(SATS_IN_USE, "%2d/",NewSatsInUse);      
    OldSatsInUse = NewSatsInUse;
    #if (LCD_2004)
      lcd.setCursor(15, 0);
      lcd.print(SATS_IN_USE);
    #endif  
  }
}

void UpdateSatsInView ()
{
  NewSatsInView = String(satsInView.value()).toInt();
  if (NewSatsInView != OldSatsInView){
    sprintf(SATS_IN_VIEW, "%2d",NewSatsInView);      
    OldSatsInView = NewSatsInView;
    #if (LCD_2004)
      lcd.setCursor(18, 0);
      lcd.print(SATS_IN_VIEW);
    #endif  
  }
}

void UpdateSatFixMode()
{
  NewFixMode = String(satFixMode.value()).toInt();
  if (NewFixMode != OldFixMode){
    OldFixMode = NewFixMode;
    if (ScreenNew <= 6){
      #if (LCD_2004)
        lcd.setCursor(0, 0);
      #endif  
      if (NewFixMode <= 1){
        #if (LCD_2004)
          lcd.print(MSG_GPS_UNLOCK);
        #endif
        Fix_Days = 0;
        Fix_Hours = 0;
        Fix_Minutes = 0;
        Fix_Seconds = 0; 
        ProgFixTime = 0;
        OldFixTime = 0;
        sprintf(PROG_FIX_TIME, "%4d %2d:%02d:%02d",Fix_Days,Fix_Hours,Fix_Minutes,Fix_Seconds);
        sprintf(OLD_FIX_TIME, "%4d %2d:%02d:%02d",Fix_Days,Fix_Hours,Fix_Minutes,Fix_Seconds);
        if (ScreenNew == 5){
          #if (LCD_2004)
            lcd.setCursor(5, 2);
            lcd.print(PROG_FIX_TIME);
          #endif  
        }
      }
      if (NewFixMode == 2){
        #if (LCD_2004)
          lcd.print(MSG_GPS_LOCK_2D); 
        #endif
      }
      if (NewFixMode == 3){
        #if (LCD_2004)
          lcd.print(MSG_GPS_LOCK_3D); 
        #endif
      }
    }
  }
}

void UpdateRunTimers()
{
  unsigned long RunTimer = millis();
  ProgRunTime += (RunTimer - OldRunTime);
  OldRunTime = RunTimer;
  if (ProgRunTime > 999) {
    ProgRunTime -= 1000;
    Running_Seconds += 1;
    if (Running_Seconds > 59) {
      Running_Seconds -= 60;
      Running_Minutes += 1;    
    }
    if (Running_Minutes > 59) {
      Running_Minutes -= 60;
      Running_Hours += 1;    
    }
    if (Running_Hours > 23) {
      Running_Hours -= 24;
      Running_Days += 1;    
    }
    sprintf(PROG_RUN_TIME, "%4d %2d:%02d:%02d",Running_Days,Running_Hours,Running_Minutes,Running_Seconds);
  }
  if (strcmp(PROG_RUN_TIME,OLD_RUN_TIME)!=0) {
    sprintf(OLD_RUN_TIME, "%4d %2d:%02d:%02d",Running_Days,Running_Hours,Running_Minutes,Running_Seconds);
    if (ScreenNew == 5){
      #if (LCD_2004)
        lcd.setCursor(5,1);
        lcd.print(PROG_RUN_TIME);
      #endif  
    }  
  }
 
  if (NewFixMode > 1){
    ProgFixTime += (RunTimer - OldFixTime);
    OldFixTime = RunTimer;
    if (ProgFixTime > 999) {
      ProgFixTime -= 1000;
      Fix_Seconds += 1;
      if (Fix_Seconds > 59) {
        Fix_Seconds -= 60;
        Fix_Minutes += 1;    
      }
      if (Fix_Minutes > 59) {
        Fix_Minutes -= 60;
        Fix_Hours += 1;    
      }
      if (Fix_Hours > 23) {
        Fix_Hours -= 24;
        Fix_Days += 1;    
      }
      sprintf(PROG_FIX_TIME, "%4d %2d:%02d:%02d",Fix_Days,Fix_Hours,Fix_Minutes,Fix_Seconds);
    }
    if (strcmp(PROG_FIX_TIME,OLD_FIX_TIME)!=0) {
      sprintf(OLD_FIX_TIME, "%4d %2d:%02d:%02d",Fix_Days,Fix_Hours,Fix_Minutes,Fix_Seconds);
      if (ScreenNew == 5){
        #if (LCD_2004)
          lcd.setCursor(5,2);
          lcd.print(PROG_FIX_TIME);
        #endif  
      } 
    } 
  }
  else {
    OldFixTime = RunTimer;
  }
}

void BuildScreen0 ()
{
  #if (LCD_2004)
    LcdWipeClean();
    lcd.setCursor(5, 0);
    lcd.print(MSG_FREE);
    lcd.setCursor(0, 1);
    lcd.print(MSG_TIME_UTC);
  #endif
  OldSatsInUse = -1;
  OldSatsInView = -1;
  OldFixMode = -1;
  GpsTimeHourOld = -1;
  GpsTimeMinuteOld = -1;
  GpsTimeSecondOld = -1;
  GpsDateDayOld = -1;
  GpsDateMonthOld = -1;
  GpsDateYearOld = -1;
}

void BuildScreen1 ()
{
  #if (LCD_2004)
    LcdWipeClean();
    lcd.setCursor(5, 0);
    lcd.print(MSG_FREE);
    lcd.setCursor(0, 1);
    lcd.print(MSG_TIME_LOCAL);
  #endif
  OldSatsInUse = -1;
  OldSatsInView = -1;
  OldFixMode = -1;
  LocalTimeHourOld = -1;
  LocalTimeMinuteOld = -1;
  LocalTimeSecondOld = -1;
  LocalDateDayOld = -1;
  LocalDateMonthOld = -1;
  LocalDateYearOld = -1;
}

void BuildScreen2 ()
{
  #if (LCD_2004)
    LcdWipeClean();
    lcd.setCursor(5, 0);
    lcd.print(MSG_FREE);
    lcd.setCursor(0, 1);
    lcd.print(MSG_TIME_UTC);
    lcd.setCursor(10, 1);
    lcd.print(MSG_TIME_LOCAL);
  #endif
  OldSatsInUse = -1;
  OldSatsInView = -1;
  OldFixMode = -1;
  GpsTimeHourOld = -1;
  GpsTimeMinuteOld = -1;
  GpsTimeSecondOld = -1;
  GpsDateDayOld = -1;
  GpsDateMonthOld = -1;
  GpsDateYearOld = -1;
  LocalTimeHourOld = -1;
  LocalTimeMinuteOld = -1;
  LocalTimeSecondOld = -1;
  LocalDateDayOld = -1;
  LocalDateMonthOld = -1;
  LocalDateYearOld = -1;
}

void BuildScreen3 ()
{
  #if (LCD_2004)
    LcdWipeClean();
    lcd.setCursor(5, 0);
    lcd.print(MSG_FREE);
    lcd.setCursor(0, 1);
    lcd.print(MSG_GPS_LAT);
    lcd.setCursor(0, 2);
    lcd.print(MSG_GPS_LON);
    lcd.setCursor(0, 3);
    lcd.print(MSG_LOCATOR);
  #endif
  OldSatsInUse = -1;
  OldSatsInView = -1;
  OldFixMode = -1;
  strncpy(OLD_LAT, "000.000000", 10);
  OLD_LAT_IND[0] = char(32);
  strncpy(OLD_LNG, "000.000000", 10);
  OLD_LNG_IND[0] = char(32);
  strncpy(OLD_LOCATOR, "      ", 6);
  LatUpdate = true;
  LngUpdate = true;
}

void BuildScreen4 ()
{
  #if (LCD_2004)
    LcdWipeClean();
    lcd.setCursor(5, 0);
    lcd.print(MSG_FREE);
    lcd.setCursor(0, 1);
    lcd.print(MSG_GPS_LAT);
    lcd.setCursor(0, 2);
    lcd.print(MSG_GPS_LON);
    lcd.setCursor(0, 3);
    lcd.print(MSG_LOCATOR);
  #endif
  OldSatsInUse = -1;
  OldSatsInView = -1;
  OldFixMode = -1;
  strncpy(OLD_LAT, "000.000000", 10);
  OLD_LAT_IND[0] = char(32);
  strncpy(OLD_LNG, "000.000000", 10);
  OLD_LNG_IND[0] = char(32);
  strncpy(OLD_LOCATOR, "      ", 6);
  LatUpdate = true;
  LngUpdate = true;
}

void BuildScreen5 ()
{
  #if (LCD_2004)
    LcdWipeClean();
    lcd.setCursor(5, 0);
    lcd.print(MSG_FREE);
    lcd.setCursor(0, 1);
    lcd.print(MSG_PROG_RUN);
    lcd.setCursor(0, 2);
    lcd.print(MSG_GPS_FIX);
  #endif
  OldSatsInUse = -1;
  OldSatsInView = -1;
  OldFixMode = -1;
}

void BuildScreen6 ()
{
  unsigned int BlockVal = 0;
  #if (LCD_2004)
    LcdWipeClean();
    lcd.setCursor(5, 0);
    lcd.print(MSG_FREE);
    lcd.setCursor(0,2);
    lcd.print("-");
    lcd.print((char)0);
    do {
      lcd.print((char)2);
      BlockVal ++;
    } while (BlockVal < 16);
    lcd.print((char)1);
    lcd.print("+");
    LCD2004Meter();
  #endif
  OldSatsInUse = -1;
  OldSatsInView = -1;
  OldFixMode = -1;
}

void BuildScreen7 ()
{
  #if (LCD_2004)
    LcdWipeClean();
    lcd.setCursor(0, 0);
    lcd.print(MSG_HARDWARE_OPTION);
    lcd.setCursor(0,1);
    lcd.print(MSG_HARDWARE_RS232C);
    if (RS232chip == 1) lcd.print(MSG_ON); else lcd.print(MSG_OFF);
    lcd.setCursor(0,2);
    lcd.print(MSG_HARDWARE_SI5351);
    if (Si5351chip == 1) lcd.print(MSG_ON); else lcd.print(MSG_OFF);
    lcd.setCursor(0,3);
    lcd.print(MSG_HARDWARE_ADF4351);
    if (Adf4351chip == 1) lcd.print(MSG_ON); else lcd.print(MSG_OFF);
  #endif
}

void BuildScreen8 ()
{
  #if (LCD_2004)
    LcdWipeClean();
    lcd.setCursor(0, 0);
    lcd.print(MSG_USB_NMEA);
    lcd.setCursor(12,0);
    if (NmeaUSBOn == 1) lcd.print(MSG_ON); else lcd.print(MSG_OFF);
    lcd.setCursor(1,1);
    lcd.print(MSG_BAUD_RATE);
    lcd.setCursor(12,1);
    switch (NmeaUSBBaud){
      case 9600:
        lcd.print(MSG_BAUD_9600);
        break;
      case 19200:
        lcd.print(MSG_BAUD_19200);
        break;
      case 38400:
        lcd.print(MSG_BAUD_38400);
        break;
      case 57600:
        lcd.print(MSG_BAUD_57600);
        break;
      case 115200:
        lcd.print(MSG_BAUD_115200);
        break;
    }
  #endif  

  if (RS232chip == 1) {
    #if (LCD_2004)
      lcd.setCursor(0, 2);
      lcd.print(MSG_RS232C_NMEA);
      lcd.setCursor(12,2);
      if (NmeaRS232On == 1) lcd.print(MSG_ON); else lcd.print(MSG_OFF);
      lcd.setCursor(1,3);
      lcd.print(MSG_BAUD_RATE);
      lcd.setCursor(12,3);
      switch (NmeaRS232Baud){
        case 4800:
          lcd.print(MSG_BAUD_4800);
          break;
        case 9600:
          lcd.print(MSG_BAUD_9600);
          break;
        case 19200:
          lcd.print(MSG_BAUD_19200);
          break;
        case 38400:
          lcd.print(MSG_BAUD_38400);
          break;
        case 57600:
          lcd.print(MSG_BAUD_57600);
          break;
        case 115200:
          lcd.print(MSG_BAUD_115200);
          break;
      }
    #endif
  }
}

void BuildScreen9 ()
{
  #if (LCD_2004)
    LcdWipeClean();
    lcd.setCursor(0, 0);
    lcd.print(MSG_FUN_OPTION);
    lcd.setCursor(0, 1);
    lcd.print(MSG_LCD_TOT);
    switch (LcdTot){
      case 0:
        lcd.print(MSG_LCD_TOT_OFF);
        break;
      case 1:
        lcd.print(MSG_LCD_TOT_01MIN);
        break;
      case 2:
        lcd.print(MSG_LCD_TOT_02MIN);
        break;
      case 3:
        lcd.print(MSG_LCD_TOT_03MIN);
        break;
      case 4:
        lcd.print(MSG_LCD_TOT_04MIN);
        break;
      case 5:
        lcd.print(MSG_LCD_TOT_05MIN);
        break;
      case 6:
        lcd.print(MSG_LCD_TOT_10MIN);
        break;
      case 7:
        lcd.print(MSG_LCD_TOT_15MIN);
        break;
      case 8:
        lcd.print(MSG_LCD_TOT_30MIN);
        break;
    }
    lcd.setCursor(0, 2);
    lcd.print(MSG_LCD_PLL);
    switch (PllMod){
      case 0:
        lcd.print(PLL_MOD_0);
        break;
      case 1:
        lcd.print(PLL_MOD_1);
        break;
      case 2:
        lcd.print(PLL_MOD_2);
        break;
      case 3:
        lcd.print(PLL_MOD_3);
        break;
      case 4:
        lcd.print(PLL_MOD_4);
        break;
    }
//      lcd.print(PllMod);
  #endif
}

void BuildScreen10 ()
{
  sprintf(NEW_SI_0_HERTZ,"%3d.%03d.%03d,%02d",Si0MHertz,Si0kHertz,Si0Hertz,Si0mHertz);
  #if (LCD_2004)
    LcdWipeClean();
    lcd.setCursor(0, 0);
    lcd.print(MSG_SI_CLK0);
    lcd.setCursor(0, 1);
    lcd.print(MSG_OUTPUT);
    if (Si0Level == 0) lcd.print(MSG_OFF); 
    else if (Si0Level == 1) lcd.print(MSG_LOW);
    else if (Si0Level == 2) lcd.print(MSG_MID);
    else if (Si0Level == 3) lcd.print(MSG_HIGH);
    lcd.setCursor(0, 2);
    lcd.print(NEW_SI_0_HERTZ);
    lcd.print(MSG_HERZ);
 #endif  
}

void BuildScreen11 ()
{
  sprintf(NEW_SI_1_HERTZ,"%3d.%03d.%03d,%02d",Si1MHertz,Si1kHertz,Si1Hertz,Si1mHertz);
  #if (LCD_2004)
    LcdWipeClean();
    lcd.setCursor(0, 0);
    lcd.print(MSG_SI_CLK1);
    lcd.setCursor(0, 1);
    lcd.print(MSG_OUTPUT);
    if (Si1Level == 0) lcd.print(MSG_OFF); 
    else if (Si1Level == 1) lcd.print(MSG_LOW);
    else if (Si1Level == 2) lcd.print(MSG_MID);
    else if (Si1Level == 3) lcd.print(MSG_HIGH);
    lcd.setCursor(0, 2);
    lcd.print(NEW_SI_1_HERTZ);
    lcd.print(MSG_HERZ);
  #endif  
}

void BuildScreen12 ()
{
  sprintf(NEW_SI_2_HERTZ,"%3d.%03d.%03d,%02d",Si2MHertz,Si2kHertz,Si2Hertz,Si2mHertz);
  #if (LCD_2004)
    LcdWipeClean();
    lcd.setCursor(0, 0);
    lcd.print(MSG_SI_CLK2);
    lcd.setCursor(0, 1);
    lcd.print(MSG_OUTPUT);
    if (Si2Level == 0) lcd.print(MSG_OFF); 
    else if (Si2Level == 1) lcd.print(MSG_LOW);
    else if (Si2Level == 2) lcd.print(MSG_MID);
    else if (Si2Level == 3) lcd.print(MSG_HIGH);
    lcd.setCursor(0, 2);
    lcd.print(NEW_SI_2_HERTZ);
    lcd.print(MSG_HERZ);
  #endif  
}

void BuildScreen13 ()
{
  sprintf(NEW_ADF_HERTZ,"%4d.%03d.%03d",AdfMHz,AdfkHz,AdfHz);
  #if (LCD_2004)
    LcdWipeClean();
    lcd.setCursor(0, 0);
    lcd.print(MSG_ADF_CLK);
    lcd.setCursor(0, 1);
    lcd.print(MSG_OUTPUT);
    if (AdfLevel == 0) lcd.print(MSG_OFF); 
    else {
      sprintf(MSG_LEVEL, "%1d   ", AdfLevel-1);
      lcd.print(MSG_LEVEL);
    }
    lcd.setCursor(0, 2);
    lcd.print(NEW_ADF_HERTZ);
    lcd.print(MSG_HERZ);
  #endif  
}

void ScreenState ()
{
  if (ScreenNew != ScreenPrevious) {
    ScreenPrevious = ScreenNew;
    switch (ScreenNew){
    case 0:
      BuildScreen0();
      break;
    case 1:
      BuildScreen1();
      break;
    case 2:
      BuildScreen2();
      break;
    case 3:
      BuildScreen3();
      break;
    case 4:
      BuildScreen4();
      break;
    case 5:
      BuildScreen5();
      break;
    case 6:
      BuildScreen6();
      break;
    case 7:
      BuildScreen7();
      break;
    case 8:
      BuildScreen8();
      break;
    case 9:
      BuildScreen9();
      break;
    case 10:
      BuildScreen10();
      break;
    case 11:
      BuildScreen11();
      break;
    case 12:
      BuildScreen12();
      break;
    case 13:
      BuildScreen13();
      break;
    }
  }
}


void GpsHardwareFail () {
  // Stop all serial communication
  Serial.end();
  Serial1.end();
  Serial2.end();
  Serial3.end();
  #if (LCD_2004)
    lcd.clear();
    lcd.setCursor(5, 1);
    lcd.print(MSG_GPS);
    lcd.setCursor(5, 2);
    lcd.print(MSG_FAIL);
  #endif  
  while (true) {
    // do nothing forever and blink first led as warning at 4 Hz.
    if (((millis()-Led1Blink)) >= 250) {
      Led1Blink = millis();
      if (Led1Stat == SINGLE_OFF) {
        Led1Stat = SINGLE_ON;
        LedSwitch (Led1,Led1Mode,Led1Stat);
      }
      else {
        Led1Stat = SINGLE_OFF;
        LedSwitch (Led1,Led1Mode,Led1Stat);
      }
    }
  }
}

void Start_Display_Welcome () {
  #if (LCD_2004)
    lcd.init();                       // initialize the lcd
    lcd.backlight();                  // Lcd backlight on
    lcd.setCursor(4, 0);
    lcd.print(MSG_VERSION);
    lcd.setCursor(2, 1);
    lcd.print(MSG_WELCOME);
    lcd.setCursor(2, 2);
    lcd.print(MSG_SETUP);
  #endif
}
//eof
